# -*- coding: utf-8 -*-
"""
/***************************************************************************
 senpviewer3
                                 A QGIS plugin
 Opent de viewer van Slagboom en Peeters
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2018-03-22
        git sha              : $Format:%H$
        copyright            : (C) 2018 by GeoFocus
        email                : info@geofocus.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from PyQt5.QtCore import QSettings, QTranslator, qVersion, QCoreApplication, Qt
from PyQt5.QtGui import QIcon, QCursor
from PyQt5.QtWidgets import QAction, QApplication
from qgis.gui import QgsMapTool

# Initialize Qt resources from file resources.py
from .resources import *
# Import the code for the dialog
from .senpviewer3_dialog import senpviewer3Dialog
import os.path
import webbrowser

class senpviewer3:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'senpviewer3_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)

            if qVersion() > '4.3.3':
                QCoreApplication.installTranslator(self.translator)

        # Create the dialog (after translation) and keep reference
        self.dlg = senpviewer3Dialog()

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&senpviewer3')
        # TODO: We are going to let the user set this up in a future iteration
        self.toolbar = self.iface.addToolBar(u'senpviewer3')
        self.toolbar.setObjectName(u'senpviewer3')

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('senpviewer3', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            self.toolbar.addAction(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/senpviewer3/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'senpviewer'),
            callback=self.run,
            parent=self.iface.mainWindow())

        # SETTINGS
        icon_path = ':/plugins/senpviewer3/icon_settings.png'
        self.add_action(
            icon_path,
            text=self.tr(u'Instellingen'),
            callback=self.showSettings,
            parent=self.iface.mainWindow())

    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&senpviewer3'),
                action)
            self.iface.removeToolBarIcon(action)
        # remove the toolbar
        del self.toolbar

    def run(self):
        #print("running")
        tool = PointTool(self.iface.mapCanvas())
        self.iface.mapCanvas().setMapTool(tool)
        pass


    def showSettings(self):

        # wijzig cursor terug
        #QApplication.instance().setOverrideCursor(Qt.ArrowCursor)
        QApplication.restoreOverrideCursor()

        s = QSettings()  # http://docs.qgis.org/testing/en/docs/pyqgis_developer_cookbook/settings.html
        Toegangscode = s.value("senpviewer/Toegangscode", "")
        # show the dialog
        self.dlg.Toegangscode.setText(Toegangscode)  # http://stackoverflow.com/questions/18872004/error-in-python-plugin-for-qgis
        self.dlg.show()
        # Run the dialog event loop
        result = self.dlg.exec_()
        # See if OK was pressed
        if result:
            s.setValue("senpviewer/Toegangscode", self.dlg.Toegangscode.text())
            pass

class PointTool(QgsMapTool):

    def __init__(self, canvas):
        # print("init pointtool")
        # import webbrowser
        # webbrowser.open('www.google.com')
        QgsMapTool.__init__(self, canvas)
        self.canvas = canvas

    def canvasPressEvent(self, event):
        #print("klik!")
        pass

    def canvasMoveEvent(self, event):
        pass

    def canvasReleaseEvent(self, event):

        s = QSettings()  # http://docs.qgis.org/testing/en/docs/pyqgis_developer_cookbook/settings.html
        Toegangscode = s.value("senpviewer/Toegangscode", "")

        # Get the click
        x = event.pos().x()
        y = event.pos().y()
        # print (str(x) + " " + str(y))
        point = self.canvas.getCoordinateTransform().toMapCoordinates(x, y)
        #print (str(point.x()) + " " + str(point.y()))

        # url = "http://obliek.slagboomenpeeters.com/index_popup.php?appcode=delftdemoobliek2011&x=<x>&y=<y>&srid=EPSG:28992&mwidth=1000&mheight=450&richting=NOORD&zl=9"
        # url = "http://viewer.slagboomenpeeters.com/?dataset=<dataset>&renderer=2d&pos=<x>_<y>_250&tab=oblique&ref=qgis3"
        url = "https://app.slagboomenpeeters.com/<toegangscode>?x=<x>&y=<y>&z=12&mode=oblique";
        url = url.replace("<x>", str(int(round(point.x()))));
        url = url.replace("<y>", str(int(round(point.y()))));
        url = url.replace("<toegangscode>", Toegangscode);
        #print(url)
        webbrowser.open(url,new=0)  # open een externe webbrowser (geeft steeds nieuw tabblad of venster)

        pass

    def activate(self):

        self.canvas.setCursor(Qt.CrossCursor)

        #cursor = QCursor()
        #cursor.setShape(Qt.WhatsThisCursor)


        #wijzig cursor
        #https://gis.stackexchange.com/questions/185783/changing-qgis-cursor-size-and-color/185804
        #http://doc.qt.io/archives/qt-4.8/qt.html#CursorShape-enum
        #QApplication.instance().setOverrideCursor(Qt.CrossCursor)

        pass

    def deactivate(self):

        # wijzig cursor terug
        #https://stackoverflow.com/questions/8218900/how-can-i-change-the-cursor-shape-with-pyqt
        QApplication.restoreOverrideCursor()


        pass

    def isZoomTool(self):
        return False

    def isTransient(self):
        return False

    def isEditTool(self):
        return True



